#include "PageWeb.h"

char *getPageWeb() {
 char *S="<!doctype html>\r"
  "<html><head><style>"
    "body {background: linear-gradient(#003,#226,#003);font-size:150%;' onload='LoadData();}"
    "td { text-align: left;padding:2px;}"
    ".ri { text-align: right;}"
    ".ce { text-align: center;}"
    ".FS80 { font-size: 80%;}"
    ".grey { background-color:#ddd;}"
    ".blue { background-color:#ddf;}"
    "svg { border:10px inset azure;background: linear-gradient(#333,#666,#333);}"
  "</style></head>"
  "<body  onload='document.getElementsByTagName(\"body\")[0].style.fontSize =window.innerHeight/10+\"%\";LoadData();' >\r<h2 style='text-align:center;color:white'>Total Power Consumption</h2>\r"
    "<div style='display:float;width:100%;text-align:center;'>\r"
      "<div style='width:600px;display:inline-block;vertical-align:top;margin:10px;position:relative;'>\r<table align='center' style='border:10px inset azure;padding:4px;background-color:grey;font-size:120%;width:100%;'>\r"
      "<tr class='grey'><td>U :</td><td class='ri' id='Uef'> Uef </td><td class='FS80'>V</td></tr>\r"
      "<tr class='blue'><td>I :</td><td class='ri' id='Ief'> Ief</td><td class='FS80'>A</td></tr>\r"
      "<tr class='grey'><td>PW :</td><td class='ri' id='PW'>PW</td><td class='FS80'>W</td></tr>\r"
      "<tr class='blue'><td>PVA :</td><td class='ri' id='PVA'> PVA</td><td class='FS80'>VA</td></tr>\r"
      "<tr class='grey'><td>Power Factor : </td><td class='ri' id='PowerFactor'> PowerFactor</td><td></td></tr>\r"
      "<tr class='blue'><td>kWh :</td><td class='ri' id='Wh'> Wh  </td><td class='FS80'>kWh</td></tr>\r"
      "<tr class='grey'><td>Hours On :</td><td class='ri' id='Heure'> Heure </td><td class='FS80'>H</td></tr>\r"
      "<tr class='blue'><td>THDv + N :</td><td class='ri' id='THDv'> THDv </td><td class='FS80'>%</td></tr>\r"
      "<tr class='grey'><td>THDi + N :</td><td class='ri' id='THDi'> THDi </td><td class='FS80'>%</td></tr>\r"
      "</table>\r</div>\r"

      "<div class='ce' style='text-align:center;width:1050px;display:inline-block;vertical-align:top;position:relative;'>\r"
        "<div  class='ce'>\r<h2 style='position:absolute;top:20px;right:40px;'><span style='color:red;'>U_</span><span style='color:lightgreen;'> I_</span></h2>\r"
        "<p id='SVG'></p></div>\r"

        "<div style='width:1000px;margin:auto;border:10px inset azure;background: linear-gradient(#333,#666,#333);height:20px;position:relative;' id='PW_graph'></div>\r"
        "<div style='width:96%;margin:auto;margin-top:10px;position:relative;color:white;' ><h3>Chauffe-Eau / Water-Heater <small><span id='retard_'></span>%</small></h3></div>\r"
        "<div style='width:96%;margin:auto;position:relative;display: flex;justify-content: space-between;color:white;' >\r"
          "<div><input  name='mode' onclick='choix_mode(0);' type='radio' id='M0'   > <label for='M0'>Auto</label></div>\r"
          "<div><input  name='mode' onclick='choix_mode(1);' type='radio'  id='M1'  ><label for='M1'>Off</label></div>\r"
          "<div><input  name='mode' onclick='choix_mode(2);' type='radio'  id='M2'  ><label for='M2'>25%</label></div>\r"
          "<div><input  name='mode' onclick='choix_mode(3);' type='radio'  id='M3'  ><label for='M3'>50%</label></div>\r"
          "<div><input  name='mode' onclick='choix_mode(4);' type='radio'  id='M4'  ><label for='M4'>75%</label></div>\r"
          "<div><input  name='mode' onclick='choix_mode(5);' type='radio'  id='M5'  ><label for='M5'>100%</label></div>\r"
        "</div>\r"
        
      "</div>\r"
    "<div>\r"
    "<script>\r"
      "function LoadData(){\r"
        "var xhttp = new XMLHttpRequest();\r"
        "xhttp.onreadystatechange = function() { \r"
          "if (this.readyState == 4 && this.status == 200) {\r"
            "var values=this.responseText.split('|');\r"
            "var datas=values[0].split(',');\r"
            "document.getElementById('Uef').innerHTML = datas[0];\r"
            "document.getElementById('Ief').innerHTML = datas[1];\r"
            "document.getElementById('PW').innerHTML = datas[2];\r"
            "document.getElementById('PVA').innerHTML = datas[3];\r"
            "document.getElementById('PowerFactor').innerHTML = datas[4];\r"
            "document.getElementById('Wh').innerHTML = datas[5];\r"
            "document.getElementById('Heure').innerHTML = datas[6];\r"
            "document.getElementById('M'+datas[7]).checked = true; //ModeHeater\r"
            "document.getElementById('retard_').innerHTML = 100-datas[8];\r"
            "document.getElementById('THDv').innerHTML = datas[9];\r"
            "document.getElementById('THDi').innerHTML = datas[10];\r"
            "var volt=values[1].split(',');\r"
            "var amp=values[2].split(',');\r"
            "var S= \"<svg height='400' width='1000' >\";\r"
            "S += \"<line x1='0' y1='400' x2='0' y2='0' style='stroke:rgb(0,0,0);stroke-width:2' />\";\r"
            "S += \"<line x1='0' y1='200' x2='1000' y2='200' style='stroke:rgb(0,0,0);stroke-width:2' />\";\r"
            
            "var  Vmax = 500;"
            "var Imax = 500;\r"
            "for (var i = 0; i < 100; i++) {\r"
              "Vmax = Math.max(Math.abs(volt[i]), Vmax);\r"
              "Imax = Math.max(Math.abs(amp[i]), Imax);\r"
            "}\r"
            "S += \"<polyline points='\";\r"
            "for (var i = 0; i < 100; i++) {\r"
              "var Y = 200 - 200 * volt[i] / Vmax;\r"
              "var X = 10 * i;\r"
              "S += X + ',' + Y + ' ';\r"
            "}\r"
            "S += \"' style='fill:none;stroke:red;stroke-width:6' />\";\r"
            "S += \"<polyline points='\";\r"
            "for (var i = 0; i < 100; i++) {\r"
              "var Y = 200 - 200 * amp[i] / Imax;\r"
              "var X = 10 * i;\r"
              "S += X + ',' + Y + ' ';\r"
            "}\r"
            "S += \"' style='fill:none;stroke:lightgreen;stroke-width:6' />\";\r"
            "S += \"</svg>\";\r"
            "document.getElementById('SVG').innerHTML = S;\r"
            "var  X = 0;\r"
            "var Y = 99 - 99 * datas[2] / 12000;//PW\r"
            "var C='orange';\r"
            "if (datas[2] < 0) { //PW\r"
              "X = 198 - Y;\r"
              "Y = 0;\r"
              "C='green';\r"
            "}\r"
            "S = \"<div style='position:absolute;top:0px;height:20px;background-color:\" + C +\";left:\" + X + \"%;right:\" + Y + \"%;'></div>\";\r"
            "document.getElementById('PW_graph').innerHTML = S;\r"
            "setTimeout('LoadData();',2000);\r"
          "}\r"
        "};\r"
        "xhttp.open('GET', 'ajax_data', true);\r"
        "xhttp.send();\r"
      "}\r"
      "function choix_mode(M){\r"
        "var xhttp = new XMLHttpRequest();\r"
        "xhttp.onreadystatechange = function() { \r"
          "if (this.readyState == 4 && this.status == 200) {\r"
            "var retour=this.responseText;\r"
          "}\r"
        "};\r"
        "xhttp.open('GET', 'ajax_order?ModeHeater='+M, true);\r"
        "xhttp.send();\r"
      "}\r"
    "</script>\r"
    "<br></body></html>\r";
  return S;
 
}
